
package de.ivu.elect.presentation.statistik.exchange;

import java.util.List;

import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.datei.entity.DateiImportBerichtCustomData;
import de.ivu.elect.business.exchange.control.AbstractImporter;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.statistik.boundary.StatistikLaufImporter;
import de.ivu.elect.business.statistik.control.StatistikLaufImportContext;
import de.ivu.elect.business.statistik.entity.StatistikLaufMitKennzeichen;
import de.ivu.elect.presentation.View;
import de.ivu.elect.presentation.exchange.AbstractImportSearchView;
import de.ivu.elect.presentation.exchange.ImportDescription;

@Named(StatistikLaufImportSearchView.COMPONENT_NAME)
@View(viewId = StatistikLaufImportSearchView.VIEW_ID, useCase = UseCasePermission.STATISTIK_LAUF_IMPORTIEREN)
public class StatistikLaufImportSearchView extends AbstractImportSearchView<List<StatistikLaufMitKennzeichen>, StatistikLaufImportContext> {

  public static final String COMPONENT_NAME = "statistikLaufImportSearchView";

  public static final String VIEW_ID = "/statistik/statistik-lauf-import-search.xhtml";

  @Inject
  private StatistikLaufImporter importer;

  @Inject
  private StatistikLaufImportDescription importDescription;

  public StatistikLaufImportSearchView() {
    super();
  }

  @Override
  protected StatistikLaufImportContext getContext() {
    return new StatistikLaufImportContext(getSelectedWahltermin());
  }

  @Override
  protected ImportDescription getImportDescription() {
    return importDescription;
  }

  @Override
  protected AbstractImporter<List<StatistikLaufMitKennzeichen>, StatistikLaufImportContext, ? > getImporter() {
    return importer;
  }

  @Override
  protected DateiImportBerichtCustomData createNewDateiImportBerichtCustomData() {
    return new DateiImportBerichtCustomData();
  }
}
